<!DOCTYPE html>


<html xmlns="http://www.w3.org/1999/xhtml">
  <head>
    <meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
    
    <title>hidapi &#8212; Mindstorms EV3 Toolbox v0.4-rc.10 documentation</title>
    
    <link rel="stylesheet" href="_static/basic.css" type="text/css" />
    <link rel="stylesheet" href="_static/pygments.css" type="text/css" />
    <link rel="stylesheet" href="_static/bootswatch-3.3.6/readable/bootstrap.min.css" type="text/css" />
    <link rel="stylesheet" href="_static/bootstrap-sphinx.css" type="text/css" />
    
    <script type="text/javascript">
      var DOCUMENTATION_OPTIONS = {
        URL_ROOT:    './',
        VERSION:     'v0.4-rc.10',
        COLLAPSE_INDEX: false,
        FILE_SUFFIX: '.html',
        HAS_SOURCE:  true
      };
    </script>
    <script type="text/javascript" src="_static/jquery.js"></script>
    <script type="text/javascript" src="_static/underscore.js"></script>
    <script type="text/javascript" src="_static/doctools.js"></script>
    <script type="text/javascript" src="_static/js/jquery-1.11.0.min.js"></script>
    <script type="text/javascript" src="_static/js/jquery-fix.js"></script>
    <script type="text/javascript" src="_static/bootstrap-3.3.6/js/bootstrap.min.js"></script>
    <script type="text/javascript" src="_static/bootstrap-sphinx.js"></script>
    <link rel="index" title="Index" href="genindex.html" />
    <link rel="search" title="Search" href="search.html" />
    <link rel="top" title="Mindstorms EV3 Toolbox v0.4-rc.10 documentation" href="index.html" />
    <link rel="next" title="usbBrickIO" href="usbBrickIO.html" />
    <link rel="prev" title="Sensor" href="Sensor.html" />
<meta charset='utf-8'>
<meta http-equiv='X-UA-Compatible' content='IE=edge,chrome=1'>
<meta name='viewport' content='width=device-width, initial-scale=1.0, maximum-scale=1'>
<meta name="apple-mobile-web-app-capable" content="yes">

  </head>
  <body role="document">

  <div id="navbar" class="navbar navbar-default navbar-fixed-top">
    <div class="container">
      <div class="navbar-header">
        <!-- .btn-navbar is used as the toggle for collapsed navbar content -->
        <button type="button" class="navbar-toggle" data-toggle="collapse" data-target=".nav-collapse">
          <span class="icon-bar"></span>
          <span class="icon-bar"></span>
          <span class="icon-bar"></span>
        </button>
        <a class="navbar-brand" href="index.html">
          Mindstorms EV3 Toolbox</a>
        <span class="navbar-text navbar-version pull-left"><b>v0.4</b></span>
      </div>

        <div class="collapse navbar-collapse nav-collapse">
          <ul class="nav navbar-nav">
            
            
              <li class="dropdown globaltoc-container">
  <a role="button"
     id="dLabelGlobalToc"
     data-toggle="dropdown"
     data-target="#"
     href="index.html">Site <b class="caret"></b></a>
  <ul class="dropdown-menu globaltoc"
      role="menu"
      aria-labelledby="dLabelGlobalToc"><ul>
<li class="toctree-l1"><a class="reference internal" href="readme.html">General</a></li>
<li class="toctree-l1"><a class="reference internal" href="examples.html">Examples</a></li>
</ul>
<ul>
<li class="toctree-l1"><a class="reference internal" href="EV3.html">EV3</a></li>
<li class="toctree-l1"><a class="reference internal" href="Motor.html">Motor</a></li>
<li class="toctree-l1"><a class="reference internal" href="Sensor.html">Sensor</a></li>
</ul>
<ul class="current">
<li class="toctree-l1 current"><a class="current reference internal" href="#">hidapi</a></li>
<li class="toctree-l1"><a class="reference internal" href="usbBrickIO.html">usbBrickIO</a></li>
<li class="toctree-l1"><a class="reference internal" href="btBrickIO.html">btBrickIO</a></li>
</ul>
</ul>
</li>
              
                <li class="dropdown">
  <a role="button"
     id="dLabelLocalToc"
     data-toggle="dropdown"
     data-target="#"
     href="#">Page <b class="caret"></b></a>
  <ul class="dropdown-menu localtoc"
      role="menu"
      aria-labelledby="dLabelLocalToc"><ul>
<li><a class="reference internal" href="#">hidapi</a></li>
</ul>
</ul>
</li>
              
            
            
              
                
  <li>
    <a href="Sensor.html" title="Previous Chapter: Sensor"><span class="glyphicon glyphicon-chevron-left visible-sm"></span><span class="hidden-sm hidden-tablet">&laquo; Sensor</span>
    </a>
  </li>
  <li>
    <a href="usbBrickIO.html" title="Next Chapter: usbBrickIO"><span class="glyphicon glyphicon-chevron-right visible-sm"></span><span class="hidden-sm hidden-tablet">usbBrickIO &raquo;</span>
    </a>
  </li>
              
            
            
            
            
              <li class="hidden-sm">
<div id="sourcelink">
  <a href="_sources/test.txt"
     rel="nofollow">Source</a>
</div></li>
            
          </ul>

          
            
<form class="navbar-form navbar-right" action="search.html" method="get">
 <div class="form-group">
  <input type="text" name="q" class="form-control" placeholder="Search" />
 </div>
  <input type="hidden" name="check_keywords" value="yes" />
  <input type="hidden" name="area" value="default" />
</form>
          
        </div>
    </div>
  </div>

<div class="container">
  <div class="row">
    <div class="col-md-12 content">
      
  <span class="target" id="module-source"></span><div class="section" id="hidapi">
<h1>hidapi<a class="headerlink" href="#hidapi" title="Permalink to this headline">¶</a></h1>
<dl class="class">
<dt id="source.hidapi">
<em class="property">class </em><code class="descclassname">source.</code><code class="descname">hidapi</code><span class="sig-paren">(</span><em>vendorID</em>, <em>productID</em>, <em>nReadBuffer</em>, <em>nWriteBuffer</em><span class="sig-paren">)</span><a class="headerlink" href="#source.hidapi" title="Permalink to this definition">¶</a></dt>
<dd><p>Interface to the hidapi library</p>
<p class="rubric">Notes</p>
<ul class="simple">
<li>Developed from the hidapi available at <a class="reference external" href="http://www.signal11.us/oss/hidapi/">http://www.signal11.us/oss/hidapi/</a>.</li>
<li>Windows: hidapi.dll needed.</li>
<li>Mac: hidapi.dylib needed. In addition, Xcode has to be installed.</li>
<li>Linux: hidapi has to be compiled on host-system.</li>
</ul>
<dl class="attribute">
<dt id="source.hidapi.handle">
<code class="descname">handle</code><a class="headerlink" href="#source.hidapi.handle" title="Permalink to this definition">¶</a></dt>
<dd></dd></dl>

<dl class="attribute">
<dt id="source.hidapi.vendorID">
<code class="descname">vendorID</code><a class="headerlink" href="#source.hidapi.vendorID" title="Permalink to this definition">¶</a></dt>
<dd><p><em>numeric</em> &#8211; Vendor-ID of the USB device.</p>
</dd></dl>

<dl class="attribute">
<dt id="source.hidapi.productID">
<code class="descname">productID</code><a class="headerlink" href="#source.hidapi.productID" title="Permalink to this definition">¶</a></dt>
<dd><p><em>numeric</em> &#8211; Product-ID of the USB device.</p>
</dd></dl>

<dl class="attribute">
<dt id="source.hidapi.nReadBuffer">
<code class="descname">nReadBuffer</code><a class="headerlink" href="#source.hidapi.nReadBuffer" title="Permalink to this definition">¶</a></dt>
<dd><p><em>numeric</em> &#8211; Read-buffer size in bytes.</p>
</dd></dl>

<dl class="attribute">
<dt id="source.hidapi.nWriteBuffer">
<code class="descname">nWriteBuffer</code><a class="headerlink" href="#source.hidapi.nWriteBuffer" title="Permalink to this definition">¶</a></dt>
<dd><p><em>numeric</em> &#8211; Write-buffer size in bytes. Needs to be 1 Byte bigger than
actual packet.</p>
</dd></dl>

<dl class="attribute">
<dt id="source.hidapi.slib">
<code class="descname">slib</code><a class="headerlink" href="#source.hidapi.slib" title="Permalink to this definition">¶</a></dt>
<dd><p><em>string</em> &#8211; Name of shared library file (without file extension). Defaults to
&#8216;hidapi&#8217;.</p>
</dd></dl>

<dl class="attribute">
<dt id="source.hidapi.sheader">
<code class="descname">sheader</code><a class="headerlink" href="#source.hidapi.sheader" title="Permalink to this definition">¶</a></dt>
<dd><p><em>string</em> &#8211; Name of shared library header. Defaults to &#8216;hidapi.h&#8217;.</p>
</dd></dl>

<p class="rubric">Example</p>
<p>hidHandle = hidapi(1684,0005,1024,1025); %|br|</p>
<dl class="method">
<dt id="source.hidapi.close">
<code class="descname">close</code><span class="sig-paren">(</span><em>hid</em><span class="sig-paren">)</span><a class="headerlink" href="#source.hidapi.close" title="Permalink to this definition">¶</a></dt>
<dd><p>Close the connection to a hid device.</p>
<dl class="docutils">
<dt>Throws:</dt>
<dd>InvalidHandle: Handle to USB-device not valid</dd>
</dl>
<p class="rubric">Notes</p>
<ul class="simple">
<li>Gets called automatically when deleting the hidapi instance.</li>
</ul>
<ol class="upperroman simple" start="2001">
<li>Check if pointer is (unexpectedly) already invalidated</li>
</ol>
</dd></dl>

<dl class="method">
<dt id="source.hidapi.enumerate">
<code class="descname">enumerate</code><span class="sig-paren">(</span><em>hid</em>, <em>vendorID</em>, <em>productID</em><span class="sig-paren">)</span><a class="headerlink" href="#source.hidapi.enumerate" title="Permalink to this definition">¶</a></dt>
<dd><p>Enumerates the info about the hid device with the given vendorID and productID
and returns a string with the returned hid information.</p>
<table class="docutils field-list" frame="void" rules="none">
<col class="field-name" />
<col class="field-body" />
<tbody valign="top">
<tr class="field-odd field"><th class="field-name">Parameters:</th><td class="field-body"><ul class="first last simple">
<li><strong>vendorID</strong> (<em>numeric</em>) &#8211; Vendor-ID of the USB device in decimal.</li>
<li><strong>productID</strong> (<em>numeric</em>) &#8211; Product-ID of the USB device in decimal.</li>
</ul>
</td>
</tr>
</tbody>
</table>
<p class="rubric">Notes</p>
<ul class="simple">
<li>Using a vendorID and productID of (0,0) will enumerate all connected hid
devices.</li>
<li>MATLAB does not have the hid_device_infoPtr struct so some of the returned
information will need to be resized and cast into uint8 or chars.</li>
</ul>
<p>Enumerate the hid devices</p>
</dd></dl>

<dl class="method">
<dt id="source.hidapi.error">
<code class="descname">error</code><span class="sig-paren">(</span><em>hid</em><span class="sig-paren">)</span><a class="headerlink" href="#source.hidapi.error" title="Permalink to this definition">¶</a></dt>
<dd><p>Return the hid device error string if a function produced an error.</p>
<dl class="docutils">
<dt>Throws:</dt>
<dd>InvalidHandle: Handle to USB-device not valid</dd>
</dl>
<p class="rubric">Notes</p>
<ul class="simple">
<li>This function must be called explicitly if you think an error was generated
from the hid device.</li>
</ul>
<ol class="upperroman simple" start="2001">
<li>Check if pointer is (unexpectedly) already invalidated</li>
</ol>
</dd></dl>

<dl class="method">
<dt id="source.hidapi.exit">
<code class="descname">exit</code><span class="sig-paren">(</span><em>hid</em><span class="sig-paren">)</span><a class="headerlink" href="#source.hidapi.exit" title="Permalink to this definition">¶</a></dt>
<dd><p>hidapi.exit Exit hidapi</p>
<p>hid.exit() exits the hidapi library.</p>
<dl class="docutils">
<dt>Throws:</dt>
<dd>CommError: Error during communication with device</dd>
</dl>
<p>Notes::
- You should not have to call this function directly.</p>
</dd></dl>

<dl class="method">
<dt id="source.hidapi.getHIDInfoString">
<code class="descname">getHIDInfoString</code><span class="sig-paren">(</span><em>hid</em>, <em>info</em><span class="sig-paren">)</span><a class="headerlink" href="#source.hidapi.getHIDInfoString" title="Permalink to this definition">¶</a></dt>
<dd><p>Get the corresponding hid info from the hid device.</p>
<dl class="docutils">
<dt>Throws:</dt>
<dd>CommError: Error during communication with device
InvalidHandle: Handle to USB-device not valid</dd>
</dl>
<p class="rubric">Notes</p>
<ul class="simple">
<li>Info is the hid information string.</li>
</ul>
<p>See also HIDAPI.GETMANUFACTURERSSTRING, HIDAPI.GETPRODUCTSTRING,
HIDAPI.GETSERIALNUMBERSTRING.</p>
<p>Read buffer nReadBuffer length</p>
</dd></dl>

<dl class="method">
<dt id="source.hidapi.getManufacturersString">
<code class="descname">getManufacturersString</code><span class="sig-paren">(</span><em>hid</em><span class="sig-paren">)</span><a class="headerlink" href="#source.hidapi.getManufacturersString" title="Permalink to this definition">¶</a></dt>
<dd><p>Get manufacturers string from hid object using getHIDInfoString.</p>
</dd></dl>

<dl class="method">
<dt id="source.hidapi.getProductString">
<code class="descname">getProductString</code><span class="sig-paren">(</span><em>hid</em><span class="sig-paren">)</span><a class="headerlink" href="#source.hidapi.getProductString" title="Permalink to this definition">¶</a></dt>
<dd><p>Get product string from hid object using getProductString.</p>
</dd></dl>

<dl class="method">
<dt id="source.hidapi.getSerialNumberString">
<code class="descname">getSerialNumberString</code><span class="sig-paren">(</span><em>hid</em><span class="sig-paren">)</span><a class="headerlink" href="#source.hidapi.getSerialNumberString" title="Permalink to this definition">¶</a></dt>
<dd><p>Get serial number from hid object using getSerialNumberString.</p>
</dd></dl>

<dl class="method">
<dt id="source.hidapi.init">
<code class="descname">init</code><span class="sig-paren">(</span><em>hid</em><span class="sig-paren">)</span><a class="headerlink" href="#source.hidapi.init" title="Permalink to this definition">¶</a></dt>
<dd><p>Inits the hidapi library.</p>
<dl class="docutils">
<dt>Throws:</dt>
<dd>CommError: Error during communication with device</dd>
</dl>
<p class="rubric">Notes</p>
<ul class="simple">
<li>This is called automatically in the library itself with the open function. You
should not have to call this function directly.</li>
</ul>
</dd></dl>

<dl class="method">
<dt id="source.hidapi.open">
<code class="descname">open</code><span class="sig-paren">(</span><em>hid</em><span class="sig-paren">)</span><a class="headerlink" href="#source.hidapi.open" title="Permalink to this definition">¶</a></dt>
<dd><p>Open a connection with a hid device</p>
<dl class="docutils">
<dt>Throws:</dt>
<dd>CommError: Error during communication with device</dd>
</dl>
<p class="rubric">Notes</p>
<ul class="simple">
<li>Gets called automatically when creating an hidapi-object.</li>
<li>The pointer return value from this library call is always null so it is not
possible to know if the open was successful.</li>
<li>The final parameter to the open hidapi library call has different types
depending on OS. On windows it is uint16, on linux/mac int32.</li>
</ul>
<p>Create a null pointer for the hid_open function (depends on OS)</p>
</dd></dl>

<dl class="method">
<dt id="source.hidapi.read">
<code class="descname">read</code><span class="sig-paren">(</span><em>hid</em><span class="sig-paren">)</span><a class="headerlink" href="#source.hidapi.read" title="Permalink to this definition">¶</a></dt>
<dd><p>Read from a hid device and returns the read bytes.</p>
<dl class="docutils">
<dt>Throws:</dt>
<dd>CommError: Error during communication with device
InvalidHandle: Handle to USB-device not valid</dd>
</dl>
<p class="rubric">Notes</p>
<ul class="simple">
<li>Will print an error if no data was read.</li>
</ul>
<p>Read buffer of nReadBuffer length</p>
</dd></dl>

<dl class="method">
<dt id="source.hidapi.read_timeout">
<code class="descname">read_timeout</code><span class="sig-paren">(</span><em>hid</em>, <em>timeOut</em><span class="sig-paren">)</span><a class="headerlink" href="#source.hidapi.read_timeout" title="Permalink to this definition">¶</a></dt>
<dd><p>Read from a hid device with a timeout and return the read bytes.</p>
<table class="docutils field-list" frame="void" rules="none">
<col class="field-name" />
<col class="field-body" />
<tbody valign="top">
<tr class="field-odd field"><th class="field-name">Parameters:</th><td class="field-body"><strong>timeOut</strong> (<em>numeric &gt;= 0</em>) &#8211; Milliseconds after which a timeout-error occurs if no
packet could be read.</td>
</tr>
</tbody>
</table>
<dl class="docutils">
<dt>Throws:</dt>
<dd>CommError: Error during communication with device
InvalidHandle: Handle to USB-device not valid</dd>
</dl>
<p>Read buffer of nReadBuffer length</p>
</dd></dl>

<dl class="method">
<dt id="source.hidapi.setNonBlocking">
<code class="descname">setNonBlocking</code><span class="sig-paren">(</span><em>hid</em>, <em>nonblock</em><span class="sig-paren">)</span><a class="headerlink" href="#source.hidapi.setNonBlocking" title="Permalink to this definition">¶</a></dt>
<dd><p>Set the non blocking flag on the hid device connection.</p>
<table class="docutils field-list" frame="void" rules="none">
<col class="field-name" />
<col class="field-body" />
<tbody valign="top">
<tr class="field-odd field"><th class="field-name">Parameters:</th><td class="field-body"><strong>nonblock</strong> (<em>numeric in {0,1}</em>) &#8211; 0 disables nonblocking, 1 enables nonblocking</td>
</tr>
</tbody>
</table>
<dl class="docutils">
<dt>Throws:</dt>
<dd>CommError: Error during communication with device
InvalidHandle: Handle to USB-device not valid</dd>
</dl>
<ol class="upperroman simple" start="2001">
<li>Check if pointer is (unexpectedly) already invalidated</li>
</ol>
</dd></dl>

<dl class="method">
<dt id="source.hidapi.write">
<code class="descname">write</code><span class="sig-paren">(</span><em>hid</em>, <em>wmsg</em>, <em>reportID</em><span class="sig-paren">)</span><a class="headerlink" href="#source.hidapi.write" title="Permalink to this definition">¶</a></dt>
<dd><p>Write to a hid device.</p>
<dl class="docutils">
<dt>Throws:</dt>
<dd>CommError: Error during communication with device
InvalidHandle: Handle to USB-device not valid</dd>
</dl>
<p class="rubric">Notes</p>
<ul class="simple">
<li>Will print an error if there is a mismatch between the buffer size and the
reported number of bytes written.</li>
</ul>
<p>Append a 0 at the front for HID report ID</p>
</dd></dl>

</dd></dl>

</div>


    </div>
      
  </div>
</div>
<footer class="footer">
  <div class="container">
    <p class="pull-right">
      <a href="#">Back to top</a>
      
    </p>
    <p>
        &copy; Copyright 2016, LfB - RWTH Aachen.<br/>
      Created using <a href="http://sphinx-doc.org/">Sphinx</a> 1.4.8.<br/>
    </p>
  </div>
</footer>
  </body>
</html>